angular.module('focaLogisticaPedidoRuta') .controller('focaModalBusquedaAvanzadaController', [
    '$scope', 'focaLogisticaPedidoRutaService', '$uibModal', '$filter',
        'focaModalService', '$uibModalInstance', 'parametrosModal',
    function($scope, focaLogisticaPedidoRutaService, $uibModal, $filter,
        focaModalService, $uibModalInstance, parametrosModal
    ) {
        $scope.cliente = '';
        $scope.seleccionarCliente = function (key) {
            if (key !== 13) {
                return;
            }
            focaModalService.modal({
                titulo: 'Clientes',
                searchText: $scope.cliente,
                query: '/cliente',
                size: 'md',
                columnas: [
                    {
                        propiedad: 'COD',
                        nombre: 'Codigo'
                    },
                    {
                        propiedad: 'NOM',
                        nombre: 'Nombre'
                    },
                    {
                        propiedad: 'CUIT',
                        nombre: 'CUIT'
                    }
                ],
            }).then(function (res) {
                $scope.cliente = res.NOM;
            }).catch(function (e) {
                console.log(e);
            });
        };

        $scope.seleccionarRemito = function () {
            var modalInstance = $uibModal.open(
                {
                    ariaLabelledBy: 'Busqueda de Remito',
                    templateUrl: 'foca-modal-remito.html',
                    controller: 'focaModalRemitoController',
                    size: 'lg',
                    resolve: { usadoPor: function () { return 'remito'; } }
                }
            );
            modalInstance.result.then(function(remito) {
                $scope.remito = remito;
                $scope.remito.numero = $filter('rellenarDigitos')(remito.lugar, 4) + '-' +  
                $filter('rellenarDigitos')(remito.numeroRemito, 6);
                $scope.cliente = remito.cliente.NOM;
            }, function () {
                    // funcion ejecutada cuando se cancela el modal
                }
            );
        };

        $scope.cancel = function () {
        $uibModalInstance.dismiss('close');
        };

        $scope.buscar = function () {
            $uibModalInstance.close(datos());
        };

        function datos () {
            var datos = {
                cliente: $scope.cliente,
                remito: $scope.remito
            };
            return datos;
        }
    }
]);
