angular.module('focaLogisticaPedidoRuta')
    .factory(
        'focaLogisticaPedidoRutaService', [
            '$http',
            '$cookies',
            'API_ENDPOINT',
            '$filter',
            function($http, $cookies, API_ENDPOINT, $filter) {
                var url = API_ENDPOINT.URL;
                return {
                    idUsuario: $cookies.get('vendedorCobrador'),
                    obtenerActividad: function(parametros) {
                        return $http.post(url + '/seguimiento/filtros', parametros);
                    },
                    numeroHojaRuta: function() {
                        return $http.get(url + '/hoja-ruta/numero-siguiente');
                    },
                    getRemitos: function(idVehiculo) {
                        return $http.get(url + '/remito/sin-hoja-ruta/' + idVehiculo);
                    },
                    cerrarDistribuicion: function(remitos) {
                        return $http.post(url + '/vehiculo/cierre-distribuicion', remitos);
                    },
                    desasociarRemitos: function(remitos, idVehiculo, sinRemitos) {
                        var idsRemitos = [];
                        for (var i = 0; i < remitos.length; i++) {
                            idsRemitos.push(remitos[i].id);
                        }
                        return $http.post(url + '/vehiculo/desasociar-remitos',
                            {
                                idsRemitos: idsRemitos,
                                idVehiculo: idVehiculo,
                                vehiculoSinRemitos: sinRemitos
                            });
                    },
                    getRemitosByIdVehiculo: function(idVehiculo, sinConfirmar, sinHojaRuta) {
                        var sinHoja = sinHojaRuta ? '/sinHojaRuta' : '';
                        return $http.get(url + '/vehiculo/obtener/remitos/' +
                            idVehiculo + '/' + this.fecha.toISOString().substring(0, 10) +
                            '/' + sinConfirmar + sinHoja);
                    },
                    getVehiculosByIdUsuario: function() {
                        return $http.get(url + '/vehiculo/usuario/' + this.idUsuario);
                    },
                    getUnidadesByFecha: function() {
                        return $http.post(url + '/vehiculo/listar/fecha',
                            {fecha: this.fecha});
                    },
                    setFechaReparto: function(fechaReparto) {
                        this.fecha = fechaReparto;
                    },
                    obtenerVehiculoById: function(idVehiculo) {
                        return $http.get(url + '/vehiculo/' + idVehiculo);
                    }
            };
    }]);
